import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Calc extends JFrame implements ActionListener {

  JLabel display;

  int state;
  String op1, op2;

  public Calc()
  {
    super( "A Simple Calculator" );

    state = 0;
    op1 = "";
    op2 = "";

    setSize( 150, 100 );
    setResizable( false );
    setLocationRelativeTo( null );
    setDefaultCloseOperation( EXIT_ON_CLOSE );

    display = new JLabel("0");
    display.setBackground( Color.white );
    display.setHorizontalAlignment( SwingConstants.RIGHT );

    JPanel p = new JPanel();
    p.setLayout( new GridLayout(2,2) );
    JButton b;
    p.add( (b = new JButton("1")) );
    b.addActionListener( this );
    p.add( (b = new JButton("C")) );
    b.addActionListener( this );
    p.add( (b = new JButton("+")) );
    b.addActionListener( this );
    p.add( (b = new JButton("=")) );
    b.addActionListener( this );

    Container cp = getContentPane();
    cp.add( display, BorderLayout.NORTH );
    cp.add( p, BorderLayout.CENTER );    
  }

  public void actionPerformed( ActionEvent event )
  {
    String cmd = event.getActionCommand();

    if( cmd.equals("C") )
    {
      state = 0;
      display.setText("0");
      return;
    }

    switch( state )
    {
      case 0:
      {
        if( cmd.equals("1") )
        {
          op1 = "1";
          state = 1;
          display.setText( op1 );
        }
        break;
      }

      case 1:
      {
        if( cmd.equals("1") ) op1 += "1";
        if( cmd.equals("+") ) state = 2;
        display.setText( op1 );
        break;
      }

      case 2:
      {
        if( cmd.equals("1") )
        {
          op2 = "1";
          state = 3;
          display.setText( op2 );
        }
        break;
      }

      case 3:
      {
        if( cmd.equals("1") )
        {
          op2 += "1";
          display.setText( op2 );
        }
        if( cmd.equals("+") || cmd.equals("=") )
        {
          double d = Double.parseDouble(op1) + Double.parseDouble(op2);
          op1 = "" + d;
          state = cmd.equals("+") ? 2 : 1;
          display.setText( op1 );
        }
        break;
      }

      default:
        System.err.println( "invalid state" );    
    }
  }

  public static void main( String args[] )
  {
    (new Calc()).setVisible( true );
  }
  
}

